Unit Vyrazy;

(**************************************************************************)
(* Soubor : Vyrazy.tpu                                                    *)
(* Autor  : Vrtule                                                        *)
(*          www.vrtule.webpark.cz                                         *)
(* Popis  : Tato jednotka umoznuje vyhodnocovani vyrazu v inifxu, prefixu *)
(*          a postfixu. Lze zatm vyhodnocovat jen celociselne a nelze po-*)
(*          uzit matematickych funkci (SIN, COS...)                       *)
(* Prekladac : BP, FPC                                                    *)
(* Verze  : 1.0                                                           *)
(**************************************************************************)

Interface

{$B-}

Function VyhodnotPreFix(Vyraz:String):Longint;
Function VyhodnotPostFix(Vyraz:String):LongInt;
Function VyhodnotInFix(R:String):Longint;

Implementation

Const MaxVelikost = 100;

Function VyhodnotInFix(R:String):Longint;
Var Citac,Ukaz: Word;
    I:Byte;
    H:Longint;
    Code:Integer;
    Maz:Boolean;
    Funkce:String;
begin
Maz:=True;
Citac:=0;
Ukaz:=0;
While (R[1] = '(') and (R[Length(R)] = ')') and (Maz) do
   begin
   For I:=2 To Length(R)-1 do
       begin
       Case R[I] of
            '(' : Inc(Citac);
            ')' : begin
                  if Citac <> 0 then
                     Dec(Citac);
                  end;
            end;
       end;
   if Citac = 0 then
      begin
      Delete(R,Length(R),1);
      Delete(R,1,1);
      end
   Else begin
        Citac:=0;
        Maz:=False;
        end;
   end;
Citac:=0;
Ukaz:=0;
Val(R,H,Code);
if Code <> 0 then
   begin
   For I:=1 To Length(R) Do
       begin
       Case r[I] of
            '('     : Inc(Citac);
            ')'     : Dec(Citac);
            '+','-' : begin
                      if (Citac = 0) and not (r[I-1] = 'E') then
                         Ukaz:=I;
                      end;
            '*','/' : begin
                      if Not (R[Ukaz] in ['+','-']) and
                             (Citac = 0) then
                             Ukaz:=I;
                      end;
               end;
          end;
   Case R[Ukaz] of
        '+' : VyhodnotInFix:=VyhodnotInFix(Copy(r,1,Ukaz-1))+VyhodnotInFix(Copy(R,Ukaz+1,Length(R)-Ukaz));
        '-' : VyhodnotInFix:=VyhodnotInFix(Copy(r,1,Ukaz-1))-VyhodnotInFix(Copy(R,Ukaz+1,Length(R)-Ukaz));
        '*' : VyhodnotInFix:=VyhodnotInFix(Copy(r,1,Ukaz-1))*VyhodnotInFix(Copy(R,Ukaz+1,Length(R)-Ukaz));
        '/' : VyhodnotInFix:=VyhodnotInFix(Copy(r,1,Ukaz-1)) Div VyhodnotInFix(Copy(R,Ukaz+1,Length(R)-Ukaz));
        end;
   end
Else VyhodnotInFix:=H;
end;

Function VyhodnotPreFix(Vyraz:String):Longint;
Var I : Byte;
    CisloStr : String;
    Zasobnik : Array [1..MaxVelikost] Of String[10];
    Vrchol : 0..MaxVelikost;
    Vysledek, A, B : Longint;
    Pom : Word;
    Code : Integer;
begin
CisloStr:='';
Vysledek:=0;
Vrchol:=0;
For I:=Length(Vyraz) DownTo 1 Do
    begin
    Case Vyraz[I] Of
         ' '        : begin
                      If CisloStr <> '' Then
                         begin
                         Inc(Vrchol);
                         Zasobnik[Vrchol]:=CisloStr;
                         CisloStr:='';
                         end;
                      end;
    '0'..'9'        : CisloStr:=Vyraz[I]+CisloStr;
    '+','/','*','-' : begin
                      If CisloStr <> '' Then
                         begin
                         Inc(Vrchol);
                         Zasobnik[Vrchol]:=CisloStr;
                         CisloStr:='';
                         end;
                      Val(Zasobnik[Vrchol],B,Code);
                      Dec(Vrchol);
                      Val(Zasobnik[Vrchol],A,Code);
                      Case Vyraz[I] Of
                           '+' : Vysledek:=A+B;
                           '-' : Vysledek:=B-A;
                           '*' : Vysledek:=A*B;
                           '/' : Vysledek:=B Div A;
                           end;
                      Str(Vysledek,CisloStr);
                      Zasobnik[Vrchol]:=CisloStr;
                      CisloStr:='';
                      end;
         end;
    end;
VyhodnotPreFix:=Vysledek;
end;

Function VyhodnotPostFix(Vyraz:String):LongInt;
Var I : Byte;
    CisloStr : String;
    Zasobnik : Array [1..MaxVelikost] Of String[10];
    Vrchol : 0..MaxVelikost;
    Vysledek, A, B : Longint;
    Pom : Word;
    Code : Integer;
begin
CisloStr:='';
Vysledek:=0;
Vrchol:=0;
For I:=1 To Length(Vyraz) Do
    begin
    Case Vyraz[I] Of
         ' '        : begin
                      If CisloStr <> '' Then
                         begin
                         Inc(Vrchol);
                         Zasobnik[Vrchol]:=CisloStr;
                         CisloStr:='';
                         end;
                      end;
    '0'..'9'        : CisloStr:=CisloStr+Vyraz[I];
    '+','/','*','-' : begin
                      If CisloStr <> '' Then
                         begin
                         Inc(Vrchol);
                         Zasobnik[Vrchol]:=CisloStr;
                         CisloStr:='';
                         end;
                      Val(Zasobnik[Vrchol],B,Code);
                      Dec(Vrchol);
                      Val(Zasobnik[Vrchol],A,Code);
                      Case Vyraz[I] Of
                           '+' : Vysledek:=A+B;
                           '-' : Vysledek:=A-B;
                           '*' : Vysledek:=A*B;
                           '/' : Vysledek:=A Div B;
                           end;
                      Str(Vysledek,CisloStr);
                      Zasobnik[Vrchol]:=CisloStr;
                      CisloStr:='';
                      end;
         end;
    end;
VyhodnotPostFix:=Vysledek;
end;

End.